clearWatch();
clearInterval();
var pins = [/*A15,A14,A13,*/
A10,A8,C11,C10,C9,C8,C7,C6,C5,C4,B15,B14,B13, 
B2,B3,B4,B5,B6,B7,B8,B9
/*B12 is connected with BTN1, can not be tested as follow*/
/*C15 is OSC32 */
,C12,C0,C1,C2,C3,A0,A1
,A2,A3,A4,A5,A6,A7,B0,B1,B10,B11
];

function testPins() {
  digitalWrite([LED1,LED2,LED3],1); // blue
  var pass = true;
  for (var j in pins) {
    var i;
    var passup = true;
    var passdown = true;
    for (i in pins)
      pinMode(pins[i],i==j ? "input_pullup" : "input_pulldown");
    for (i in pins) {
        if (digitalRead(pins[i]) != ((i==j)?1:0)) passup = false;
    }
     for (i in pins)
      pinMode(pins[i],i==j ? "input_pulldown" : "input_pullup");
    for (i in pins) {
        if (digitalRead(pins[i]) != ((i==j)?0:1)) passdown = false;
    }
    if (!passup) { /*print("Fail Pullup on "+pins[j]);*/ pass=false; }
    if (!passdown) { /*print("Fail Pulldown on "+pins[j]);*/ pass = false; }
  }
  pinMode(LED1);
  pinMode(LED2);
  pinMode(LED3);

  digitalWrite([LED1,LED2,LED3],0); // all off
  var l = false;   
  if (pass) {
   setInterval(function() { digitalWrite(LED2,l=!l);}, 100); // green
  } else {
   setInterval(function() { digitalWrite(LED1,l=!l);}, 100); // red
  }  
}

testPins();
// newline

