#!/bin/bash
# sudo apt-get install tmux

cd `dirname $0`

# Create tmux with 8 split windows
tmux new-session -d 'bash portmonitor.sh /dev/ttyACM0'
tmux split-window -v 'bash portmonitor.sh /dev/ttyACM4'
tmux select-pane -t 0
tmux split-window -h 'bash portmonitor.sh /dev/ttyACM2'
tmux split-window -h 'bash portmonitor.sh /dev/ttyACM3'
tmux select-pane -t 0
tmux split-window -h 'bash portmonitor.sh /dev/ttyACM1'
tmux select-pane -t 4
tmux split-window -h 'bash portmonitor.sh /dev/ttyACM6'
tmux split-window -h 'bash portmonitor.sh /dev/ttyACM7'
tmux select-pane -t 4
tmux split-window -h 'bash portmonitor.sh /dev/ttyACM5'

tmux -2 attach-session -d 
